﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Tanky
{
    abstract class Jednotka
    {
        public string Nazev { get; set; }

        public int X { get; protected set; }

        public int Y { get; protected set; }

        public virtual void Presun(int x, int y)
        {
            this.X = x;
            this.Y = y;
        }

        public abstract void Utok(Jednotka j);

        public abstract void PodejHlaseni();

        public Jednotka(int x, int y)
        {
            this.X = x;
            this.Y = y;
        }
    }

    class Tank : Jednotka
    {
        public int Palivo { get; set; }

        public override void Presun(int x, int y)
        {
            int deltaX = Math.Abs(this.X - x);
            int deltaY = Math.Abs(this.Y - y);
            double vzdalenost = Math.Sqrt(deltaX * deltaX + deltaY * deltaY); ;
            if (vzdalenost < Palivo )
            {
                Palivo -= (int)vzdalenost;
                base.Presun(x, y);
            }
        }

        public override void Utok(Jednotka j)
        {
            Console.WriteLine("Utocim na jednotku {0}", j.Nazev);
        }

        public override void PodejHlaseni()
        {
            Console.WriteLine("Tank na pozici {0}, {1}", X, Y);
        }

        public Tank(int x, int y): base(x,y)
        {
            
        }
    }

    class Vojak : Jednotka
    {
        public override void Utok(Jednotka j)
        {
            if (j is Tank)
            {
                base.Presun(X - 4, Y - 10);
            }
            else
            {
                Console.WriteLine("Utocim na jednotku {0}", j.Nazev);
            }
        }

        public override void PodejHlaseni()
        {
            Console.WriteLine("Vojak na pozici {0}, {1}", X, Y);
        }

        public Vojak(int x, int y)
            : base(x, y)
        {

        }
    }
}
