﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Zoo
{
    public static class ZooExtensions
    {
        public static void DelejKraval(this DomaciZviratko zviratko)
        {
            zviratko.UdelejZvuk();
            zviratko.UdelejZvuk();
            zviratko.UdelejZvuk();
            zviratko.UdelejZvuk();
            zviratko.UdelejZvuk();
        }
    }

    public interface ISpac
    {
        void Spi();
    }

    public interface IKockovita
    {
        int PocetKotat { get; set; }
    }

    public abstract class DomaciZviratko : ISpac
    {
        public string Jmeno { get; set; }

        public abstract void UdelejZvuk();

        public DomaciZviratko(string jmeno)
        {
            this.Jmeno = jmeno;
        }

        public void Spi()
        {
            Console.WriteLine("Zviratko slo spat.");
        }
    }

    public class Kocka : DomaciZviratko, IKockovita
    {
        public int PocetKotat { get; set; }

        public override void UdelejZvuk()
        {
            Console.WriteLine("Mnau");
        }

        public Kocka(string jmeno) : this(jmeno, 0) { }

        public Kocka(string jmeno, int pocetKotat)
            : base(jmeno)
        {
            this.PocetKotat = pocetKotat;
        }
    }

    public class Pes : DomaciZviratko
    {
        public override void UdelejZvuk()
        {
            Console.WriteLine("haf haf");
        }

        public Pes() : base("Baryk") { }
    }

    class Program
    {
        static void Main(string[] args)
        {
            Pes baryk = new Pes();
            baryk.Jmeno = "Baryk";

            Kocka micka = new Kocka("Micka");

            DomaciZviratko[] zoo = new DomaciZviratko[] {
                baryk,
                micka
            };

            for (int i = 0; i < zoo.Length; i++)
            {
                zoo[i].DelejKraval();

                if( zoo[i] is IKockovita )
                    Console.WriteLine("Kocka na {0} kotat", ((IKockovita)zoo[i]).PocetKotat);

                IKockovita kockovitaSelma = zoo[i] as IKockovita;
                if (kockovitaSelma != null)
                {
                    Console.WriteLine("Kocka na {0} kotat", kockovitaSelma.PocetKotat);
                }
            }
        }
    }
}
